#include "copyright2.h"
#include <stdio.h>
#include <sys/types.h>
#include <math.h>
#include <errno.h>
#include "Wlib.h"
#include "defs.h"
#include "struct.h"
#include "data.h"
#include "packets.h"

#include "sp.h"
#include "wtext.h"		/* here are all warnings */

/* SP_S_WARNING vari texte */
static char           *s_texte[256];   /* Better with a malloc scheme */
static char            no_memory[] = {"Not enough memory for warning string!"};

static
char *whydeadmess[] = { "", "", "[photon]", "[phaser]", "", "[explosion]",
      "", "", "", "", "", "[plasma]", "[detted photon]", "[chain explosion]",
      "[TEAM]", "", "[team det]", "[team explosion]"};
/* For INL Server */
static
char           *shiptype[NUM_TYPES] =
{"SC", "DD", "CA", "BB", "AS", "SB", "GA", "AT"};

extern char	*strcpy_return();
extern char	*itoa();
extern char	*itof();

handleSWarning(packet)
    struct warning_s_spacket *packet;
{
   char            buf[256];
   register char   *bp = buf, *s;
   register struct player *target;
   register int    damage;
   static int      arg3, arg4;	/* Here are the arguments for warnings with
				 * more than 2 arguments */
   static int      karg3, karg4, karg5;

   switch (packet->whichmessage) {
   case TEXTE:			/* damage used as tmp var */
      damage = (unsigned char) packet->argument;
      damage |= (unsigned char) packet->argument2 << 8;


      if (damage >= 0 && damage < NUMWTEXTS)
	 warning(w_texts[damage]);
      break;
   case PHASER_HIT_TEXT:
      target = &players[(unsigned char) packet->argument & 0x3f];
      damage = (unsigned char) packet->argument2;
      if ((unsigned char) packet->argument & 64)
	 damage |= 256;
      if ((unsigned char) packet->argument & 128)
	 damage |= 512;
      bp = strcpy_return(bp, "Phaser burst hit ");
      bp = strcpy_return(bp, target->p_name);
      bp = strcpy_return(bp, " for ");
      bp = itoa(bp, damage, 3, 0);
      bp = strcpy_return(bp, " points.");
      *bp = 0;
      warning(buf);
#ifdef MOO
      if(phas_msgi)
	 W_WriteText(messwi, 0, 0, textColor, buf, bp-buf, 0);
#endif
      break;
   case BOMB_INEFFECTIVE:
      bp = strcpy_return(bp, "Weapons Officer: Bombing is ineffective for ");
      bp = itoa(bp, (int)packet->argument, 3, 0);
      bp = strcpy_return(bp, " armies.");
      *bp = 0;
      warning(buf);
      break;
   case BOMB_TEXT:
      bp = strcpy_return(bp, "Bombing ");
      bp = strcpy_return(bp, planets[(unsigned char)packet->argument].pl_name);
      bp = strcpy_return(bp, ".  Sensors read ");
      bp = itoa(bp, (unsigned int)packet->argument2, 3, 0);
      bp = strcpy_return(bp, " armies left.");
      *bp = 0;
      warning(buf);
      break;
   case BEAMUP_TEXT:
      sprintf(buf, "%s: Too few armies to beam up",
	      planets[(unsigned char) packet->argument].pl_name);
      warning(buf);
      break;
   case BEAMUP2_TEXT:
      sprintf(buf, "Beaming up.  (%d/%d)", (unsigned char) packet->argument, (unsigned char) packet->argument2);
      warning(buf);
      break;
   case BEAMUPSTARBASE_TEXT:
      sprintf(buf, "Starbase %s: Too few armies to beam up",
	      players[packet->argument].p_name);
      warning(buf);
      break;
   case BEAMDOWNSTARBASE_TEXT:
      sprintf(buf, "No more armies to beam down to Starbase %s.",
	      players[packet->argument].p_name);
      warning(buf);

      break;
   case BEAMDOWNPLANET_TEXT:
      sprintf(buf, "No more armies to beam down to %s.",
	      planets[(unsigned char) packet->argument].pl_name);
      warning(buf);
      break;
   case SBREPORT:
      sprintf(buf, "Transporter Room:  Starbase %s reports all troop bunkers are full!",
	      players[packet->argument].p_name);
      warning(buf);
      break;
   case ONEARG_TEXT:
      if (packet->argument >= 0 && packet->argument < NUMVARITEXTS) {

	 sprintf(buf, vari_texts[packet->argument], (unsigned char) packet->argument2);
	 warning(buf);
      }
      break;
   case BEAM_D_PLANET_TEXT:
      sprintf(buf, "Beaming down.  (%d/%d) %s has %d armies left",

	      arg3,
	      arg4,
	      planets[(unsigned char) packet->argument].pl_name,
	      packet->argument2);
      warning(buf);
      break;
   case ARGUMENTS:
      arg3 = (unsigned char) packet->argument;
      arg4 = (unsigned char) packet->argument2;
      break;
   case BEAM_U_TEXT:
      sprintf(buf, "Transfering ground units.  (%d/%d) Starbase %s has %d armies left",
	      (unsigned char) arg3, (unsigned char) arg4, players[packet->argument].p_name, (unsigned char) packet->argument2);
      warning(buf);
      break;
   case LOCKPLANET_TEXT:
      sprintf(buf, "Locking onto %s", planets[(unsigned char) packet->argument].pl_name);
      warning(buf);
      break;
   case LOCKPLAYER_TEXT:
      sprintf(buf, "Locking onto %s", players[(unsigned char) packet->argument].p_name);
      warning(buf);
      break;

   case SBRANK_TEXT:
      sprintf(buf, "You need a rank of %s or higher to command a starbase!", ranks[packet->argument].name);
      warning(buf);
      break;
   case SBDOCKREFUSE_TEXT:
      sprintf(buf, "Starbase %s refusing us docking permission captain.",
	      players[packet->argument].p_name);
      warning(buf);
      break;
   case SBDOCKDENIED_TEXT:
      sprintf(buf, "Starbase %s: Permission to dock denied, all ports currently occupied.", players[packet->argument].p_name);
      warning(buf);
      break;
   case SBLOCKSTRANGER:
      sprintf(buf, "Locking onto %s (%c%c)",
	      players[packet->argument].p_name,
	      teamlet[players[packet->argument].p_team],
	      shipnos[players[packet->argument].p_no]);
      warning(buf);
      break;
   case SBLOCKMYTEAM:
      sprintf(buf, "Locking onto %s (%c%c) (docking is %s)",
	      players[packet->argument].p_name,
	      teamlet[players[packet->argument].p_team],
	      shipnos[players[packet->argument].p_no],
	      (players[packet->argument].p_flags & PFDOCKOK) ? "enabled" : "disabled");
      warning(buf);
      break;
   case DMKILL:
      killmesg(packet, buf, 1, karg3, karg4, karg5);
      break;
   case KILLARGS:
      karg3 = (unsigned char) packet->argument;
      karg4 = (unsigned char) packet->argument2;
      break;
   case KILLARGS2:
      karg5 = (unsigned char) packet->argument;
      break;
   case DMKILLP:
      {
	 struct mesg_spacket msg;
	 (void) sprintf(msg.mesg, "GOD->ALL %s (%c%c) killed by %s (%c)",
			players[packet->argument].p_name,
			teamlet[players[packet->argument].p_team],
			shipnos[packet->argument],
			planets[(unsigned char) packet->argument2].pl_name,
	      teamlet[planets[(unsigned char) packet->argument2].pl_owner]);
	 msg.type = SP_MESSAGE;
	 msg.mesg[79] = '\0';
	 msg.m_flags = MALL | MVALID | MKILLP;
	 msg.m_recpt = 0;
	 msg.m_from = 255;
	 handleMessage(&msg);
      }
      break;
   case DMBOMB:
      {
	 struct mesg_spacket msg;
	 char            buf1[80];
	 (void) sprintf(buf, "%-3s->%-3s", 
	    planets[(unsigned char) packet->argument2].pl_name, 
	    teamshort[planets[(unsigned char) packet->argument2].pl_owner]);
	 (void) sprintf(buf1, "We are being attacked by %s %c%c who is %d%% damaged.",
			players[packet->argument].p_name,
			teamlet[players[packet->argument].p_team],
			shipnos[packet->argument],
			arg3);
	 (void) sprintf(msg.mesg, "%s %s", buf, buf1);
	 msg.type = SP_MESSAGE;
	 msg.mesg[79] = '\0';
	 msg.m_flags = MTEAM | MVALID | MBOMB;
	 msg.m_recpt = planets[(unsigned char) packet->argument2].pl_owner;
	 msg.m_from = 255;
	 handleMessage(&msg);
      }
      break;
   case DMDEST:
      {
	 struct mesg_spacket msg;
	 char            buf1[80];
	 (void) sprintf(buf, "%s destroyed by %s (%c%c)",
			planets[(unsigned char) packet->argument].pl_name,
			players[packet->argument2].p_name,
			teamlet[players[packet->argument2].p_team],
			shipnos[(unsigned char) packet->argument2]);
	 (void) sprintf(buf1, "%-3s->%-3s",
			planets[(unsigned char) packet->argument].pl_name, teamshort[planets[(unsigned char) packet->argument].pl_owner]);
	 (void) sprintf(msg.mesg, "%s %s", buf1, buf);
	 msg.type = SP_MESSAGE;
	 msg.mesg[79] = '\0';
	 msg.m_flags = MTEAM | MVALID | MDEST;
	 msg.m_recpt = planets[(unsigned char) packet->argument].pl_owner;
	 msg.m_from = 255;
	 handleMessage(&msg);
      }
      break;
   case DMTAKE:
      {
	 struct mesg_spacket msg;
	 char            buf1[80];
	 (void) sprintf(buf, "%s taken over by %s (%c%c)",
			planets[(unsigned char) packet->argument].pl_name,
			players[packet->argument2].p_name,
			teamlet[players[packet->argument2].p_team],
			shipnos[packet->argument2]);
	 (void) sprintf(buf1, "%-3s->%-3s",
			planets[(unsigned char) packet->argument].pl_name, teamshort[players[packet->argument2].p_team]);
	 (void) sprintf(msg.mesg, "%s %s", buf1, buf);
	 msg.type = SP_MESSAGE;
	 msg.mesg[79] = '\0';
	 msg.m_flags = MTEAM | MVALID | MTAKE;
	 msg.m_recpt = players[packet->argument2].p_team;
	 msg.m_from = 255;
	 handleMessage(&msg);
      }
      break;
   case DGHOSTKILL:
      {
	 struct mesg_spacket msg;
	 ushort          damage;
	 damage = (unsigned char) karg3;
	 damage |= (unsigned char) (karg4 & 0xff) << 8;
	 (void) sprintf(msg.mesg, "GOD->ALL %s (%c%c) was kill %0.2f for the GhostBusters",
			players[(unsigned char) packet->argument].p_name, teamlet[players[(unsigned char) packet->argument].p_team],
			shipnos[(unsigned char) packet->argument],
			(float) damage / 100.0);
	 msg.type = SP_MESSAGE;
	 msg.mesg[79] = '\0';
	 msg.m_flags = MALL | MVALID;
	 msg.m_recpt = 0;
	 msg.m_from = 255;
	 handleMessage(&msg);
      }
      break;
      /* INL Daemon Mesages */
   case INLDMKILLP:
      {
	 struct mesg_spacket msg;
	 sprintf(buf, "");
	 if (arg3) {		/* Armies */
	    sprintf(buf, "+%d", arg3);
	 }
	 (void) sprintf(msg.mesg, "GOD->ALL %s(%s) (%c%c%s) killed by %s (%c)",
			players[(unsigned char) packet->argument].p_name,
	  shiptype[players[(unsigned char) packet->argument].p_ship.s_type],
		  teamlet[players[(unsigned char) packet->argument].p_team],
			shipnos[(unsigned char) packet->argument],
			buf,
			planets[(unsigned char) packet->argument2].pl_name,
	      teamlet[planets[(unsigned char) packet->argument2].pl_owner]);
	 msg.type = SP_MESSAGE;
	 msg.mesg[79] = '\0';
	 msg.m_flags = MALL | MVALID | MKILLP;
	 msg.m_recpt = 0;
	 msg.m_from = 255;
	 handleMessage(&msg);
      }
      break;
   case INLDMKILL:
      killmesg(packet, buf, 1, karg3, karg4, karg5);
      break;
   case INLDTEXTE:
      if (packet->argument >= 0 && (unsigned char) packet->argument < NUMDAEMONTEXTS) {
	 struct mesg_spacket msg;
	 strcpy(msg.mesg, daemon_texts[(unsigned char) packet->argument]);
	 msg.m_flags = MALL | MVALID;
	 msg.type = SP_MESSAGE;
	 msg.mesg[79] = '\0';
	 msg.m_recpt = 0;
	 msg.m_from = 255;
	 handleMessage(&msg);
      }
      break;
   case STEXTE:
      warning(s_texte[(unsigned char) packet->argument]);
      break;
   case SHORT_WARNING:
      {
	 struct warning_spacket *warn = (struct warning_spacket *) packet;
	 warning(warn->mesg);
      }
      break;
   case STEXTE_STRING:
      {
	 struct warning_spacket *warn = (struct warning_spacket *) packet;
	 warning(warn->mesg);
	 s_texte[(unsigned char) warn->pad2] = (char *)malloc(warn->pad3 - 4);
	 if (s_texte[(unsigned char) warn->pad2] == NULL) {
	    s_texte[(unsigned char) warn->pad2] = no_memory;
	    warning("Could not add warning! (No memory!)");
	 } else
	    strcpy(s_texte[(unsigned char) warn->pad2], warn->mesg);
      }
      break;
   default:
      warning("Unknown Short Warning!");
      printf("Unknown Short Warning: %d\n", packet->whichmessage);
      break;
   }
}

killmesg(packet, buf, shipt, karg3, karg4, karg5)

   struct warning_s_spacket 	*packet;
   char				*buf;
   int				shipt;
   int				karg3,karg4,karg5;
{
   register char	*bp = buf;
   struct mesg_spacket 	msg;
   int             	killer, victim, armies, damage;
   float           	kills;

   victim = (unsigned char) packet->argument & 0x3f;
   killer = (unsigned char) packet->argument2 & 0x3f;
   /* that's only a temp */
   damage = (unsigned char) karg3;
   damage |= (karg4 & 127) << 8;
   kills = damage / 100.0;
   armies = (((unsigned char) packet->argument >> 6) | ((unsigned char) packet->argument2 & 192) >> 4);
   if (karg4 & 128)
      armies |= 16;

   bp = strcpy_return(bp, "GOD->ALL ");
   bp = strcpy_return(bp, players[victim].p_name);
   if(shipt){
      *bp++ = ' ';
      *bp++ = '(';
      bp = strcpy_return(bp, shiptype[players[victim].p_ship.s_type]);
      *bp++ = ')';
   }

   *bp++ = ' ';
   *bp++ = '(';
   *bp++ = teamlet[players[victim].p_team];
   *bp++ = shipnos[victim];
   if(armies){
      *bp++ = '+';
      bp = itoa(bp, armies, 3, 0);
      bp = strcpy_return(bp, " armies)");
      msg.m_flags = MALL | MVALID | MKILLA;
   }
   else{
      msg.m_flags = MALL | MVALID | MKILL;
      *bp++ = ')';
   }

   bp = strcpy_return(bp, " was kill ");
   bp = itof(bp, kills);
   bp = strcpy_return(bp, " for ");
   bp = strcpy_return(bp, players[killer].p_name);
   if(shipt){
      *bp++ = ' ';
      *bp++ = '(';
      bp = strcpy_return(bp, shiptype[players[killer].p_ship.s_type]);
      *bp++ = ')';
   }
   *bp++ = ' ';
   *bp++ = '(';
   *bp++ = teamlet[players[killer].p_team];
   *bp++ = shipnos[killer];
   *bp++ = ')';
   *bp = 0;
#ifdef FEATURE
   if(F_why_dead){
      *bp ++ = ' ';
      bp = strcpy_return(bp, whydeadmess[karg5]);
      *bp = 0;
      karg5 = 0;
   }
#endif

   msg.type = SP_MESSAGE;
   strncpy(msg.mesg, buf, 79);
   msg.mesg[79] = '\0';
   msg.m_recpt = 0;
   msg.m_from = 255;
   handleMessage(&msg);
}
